<?php

/**
 * Bugs-in plugin
 *
 *
 * Created: 2007-02-24
 * Last update: 2007-04-24
 *
 * @link http://deboutv.free.fr/mantis/
 * @author DEBOUT Vincent  <deboutv@free.fr>
 */

if ( !ereg( 'plugins_page.php', $_SERVER['PHP_SELF'] ) ) {
    header( 'Location: ../../plugins_page.php' );
    exit();
}

$t_display = gpc_get_string( 'display', 'config' );

if ( $t_display == 'config' ) {

    auth_ensure_user_authenticated();

    $t_current_user_id = auth_get_current_user_id();
    $t_project_id = helper_get_current_project();

    $t_action = gpc_get_string( 'action', 'none' );
    if ( $t_action == 'update' ) {
        $t_access_level = gpc_get_int( 'access_level' );
        config_set( 'plugins_bugsin_access_level', $t_access_level, NO_USER, $t_project_id );
        header( 'Location: plugins_page.php?plugin=bugsin' );
        exit();
    }

    html_page_top1( lang_get( 'plugins_bugsin_configuration_page_title' ) );
    html_page_top2();

?>

<br />
<div align="center">
<?php

  echo str_replace( '%%project%%', '<b>' . project_get_name( $t_project_id ) . '</b>', lang_get( 'plugins_bugsin_configuration_for_project' ) );

?>
  <br /><br />
  <form name="plugins_bugsin" method="post" action="plugins_page.php">
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="project_id" value="<?php echo $t_project_id ?>" />
    <input type="hidden" name="plugin" value="bugsin" />
    <table class="width75" cellspacing="1">

      <!-- Access Level -->
      <tr <?php echo helper_alternate_class() ?>>
        <td class="category" width="30%">
          <span class="required">*</span><?php echo lang_get( 'plugins_bugsin_access_level' ); ?>
        </td>
        <td width="70%">
          <select tabindex="1" name="access_level">
            <?php
              $t_access_levels_enum_string = config_get( 'access_levels_enum_string' );
              $t_arr = explode_enum_string( $t_access_levels_enum_string );
              $t_val = config_get( 'plugins_bugsin_access_level', PLUGINS_BUGSIN_ACCESS_LEVEL_DEFAULT );
              $enum_count = count( $t_arr );
              for( $i=0; $i<$enum_count; $i++ ) {
                  $t_elem = explode_enum_arr( $t_arr[$i] );
                  $t_access_level = get_enum_element( 'access_levels', $t_elem[0] );
                  PRINT "<option value=\"$t_elem[0]\"";
                  check_selected( $t_val, $t_elem[0] );
                  PRINT ">$t_access_level</option>";
              }
            ?>
          </select>
        </td>
      </tr>

      <!-- Submit Button -->
      <tr>
        <td class="left">
          <span class="required"> * <?php echo lang_get( 'required' ) ?></span>
        </td>
        <td class="center">
          <input tabindex="2" type="submit" class="button" value="<?php echo lang_get( 'submit_button' ) ?>" />
        </td>
      </tr>

    </table>
  </form>

</div>

<?php

  html_page_bottom1( __FILE__ );
} else {
    auth_ensure_user_authenticated();

    $t_user_id = auth_get_current_user_id();
    $t_project_id = gpc_get_int( 'project_id', helper_get_current_project() );
    $f_version_id = gpc_get_int( 'version_id', 0 );
    $f_version_name = gpc_get_string( 'version_name', '' );

    $t_main_menu = config_get( 'main_menu_custom_options' );
    $t_access_level = config_get( 'plugins_bugsin_access_level', PLUGINS_BUGSIN_ACCESS_LEVEL_DEFAULT, NO_USER, $t_project_id );
    
    if ( user_get_access_level( $t_user_id ) < $t_access_level ) {
        header( 'Location: index.php' );
        exit();
    }

    html_page_top1( lang_get( 'plugins_bugsin_title' ) );
    html_page_top2();

    if ( ALL_PROJECTS == $t_project_id ) {
        $t_topprojects = $t_project_ids = user_get_accessible_projects( $t_user_id );
        foreach ( $t_topprojects as $t_project ) {
            $t_project_ids = array_merge( $t_project_ids, user_get_all_accessible_subprojects( $t_user_id, $t_project ) );
        }

        $t_project_ids = array_unique( $t_project_ids );
    } else {
        access_ensure_project_level( config_get( 'view_changelog_threshold' ), $t_project_id );
        $t_project_ids = user_get_all_accessible_subprojects( $t_user_id, $t_project_id );
        array_unshift( $t_project_ids, $t_project_id );
    }

    if ( $t_project_id != ALL_PROJECTS ) {
        echo '<form method="post" name="form_select_version" action="plugins_page.php?plugin=bugsin&display=bugsin">' . "\n";
        echo '<input type="hidden" name="plugin" value="bugsin" />' . "\n";
        echo '<input type="hidden" name="display" value="bugsin" />' . "\n";
        echo '<br />' . lang_get( 'plugins_bugsin_show_only' ) . ": \n";
        echo '<select name="version_id" class="small" onchange="document.forms.form_select_version.submit();">' . "\n";
        echo '  <option value="0"';
        if ( $f_version_id == 0 && $f_version_name == '' ) {
            echo ' selected="selected"';
        }
        echo '>&nbsp;</option>' . "\n";
        $t_version_rows = version_get_all_rows( $t_project_id, ON );
        foreach( $t_version_rows as $t_version ) {
            echo '  <option value="' . $t_version['id'];
            if ( $t_version['id'] == $f_version_id || $t_version['version'] == $f_version_name ) {
                echo '" selected="selected';
            }
            echo '">' . $t_version['version'] . '</option>' . "\n";
        }
        echo '</select>' . "\n";
        echo '<input type="submit" class="button-small" value="' . lang_get( 'switch' ) . '" />' . "\n";
        echo '</form><br />' . "\n";
    }   

    $t_project_index = 0;
    foreach( $t_project_ids as $t_project_id ) {
        if ( $t_project_index > 0 ) {
            echo '<br />';
        }

        $c_project_id = db_prepare_int( $t_project_id );
        $t_project_name = project_get_field( $t_project_id, 'name' );
        $t_can_view_private = access_has_project_level( config_get( 'private_bug_threshold' ), $t_project_id );

        $t_limit_reporters = config_get( 'limit_reporters' );
        $t_user_access_level_is_reporter = ( REPORTER == access_get_project_level( $t_project_id ) );

        $t_resolved = config_get( 'bug_resolved_status_threshold' );
        $t_bug_table = config_get( 'mantis_bug_table' );

        $t_version_rows = version_get_all_rows( $t_project_id );

        for( $i=0; $i<count( $t_version_rows ); $i++ ) {
            if ( $t_version_rows[$i]['id'] == $f_version_id || $t_version_rows[$i]['version'] == $f_version_name ) {
                $t_temp = $t_version_rows[$i];
                $t_version_rows = array();
                $t_version_rows[] = $t_temp;
                break;
            }
        }

        echo '<br /><span class="pagetitle">', string_display( $t_project_name ), ' - ', lang_get( 'plugins_bugsin_title' ), '</span><br /><br />';
        echo '<tt>';

        $i = 0;
        foreach( $t_version_rows as $t_version_row ) {
            $t_version = $t_version_row['version'];
            if( $t_version_row['released'] == 0 ) {
                continue;
            }           
            
            $c_version = db_prepare_string( $t_version );

            $t_version_id = $t_version_row['id'];

            $query = "SELECT * FROM $t_bug_table WHERE project_id='$c_project_id' AND version='$c_version' ORDER BY last_updated DESC";

            $t_description = $t_version_row['description'];
            if ( $i > 0 ) {
                echo '<br />';
            }
                
            plugins_bugsin_print_version_header( $t_version_id );
            $t_version_header_printed = true;
            $t_first_entry = true;

            $t_result = db_query( $query );

            while ( $t_row = db_fetch_array( $t_result ) ) {
                if ( !$t_can_view_private && ( $t_result->fields['view_state'] == VS_PRIVATE ) ) {
                    continue;
                }

                bug_cache_database_result( $t_row );
                
                if ( ON === $t_limit_reporters && $t_user_access_level_is_reporter &&
                    !bug_is_user_reporter( $t_result->fields['id'], $t_user_id )) {
                    continue;
                }

                $t_issue_id = $t_row['id'];

                $t_bug = bug_get( $t_issue_id );

		$t_category = is_blank( $t_bug->category ) ? '' : '<b>[' . $t_bug->category . ']</b> ';
		echo '- ', string_get_bug_view_link( $t_issue_id ), ': ', $t_category, string_attribute( $t_bug->summary );

		if ( $t_bug->handler_id != 0 ) {
			echo ' (', prepare_user_name( $t_bug->handler_id ), ')';
		}

		echo '<br />';
            }
            
            $i++;
        }
        
        echo '</tt>';
        $t_project_index++;
    }

    html_page_bottom1( __FILE__ );
}

?>
